<?php
if (!defined('ABSPATH')) exit;

function mpceGoogleMapsAddonLibrary($mpceLibrary) {
    $mapObj = new MPCEObject('mp_google_map', __('Google Maps Pro', 'mpce-gma'), 'plugins/' . MPCE_GMA_PLUGIN_NAME . '/assets/images/google-map-pro.png', array(
	    'elements' => array(
            'type' => 'group',
            'contains' => 'mp_google_map_marker',
            'items' => array(
                'label' => array(
                    'default' => __('Marker', 'mpce-gma'),
                    'parameter' => 'title'
                ),
                'count' => 0
            ),
            'text' => __('Add new Marker', 'mpce-gma'),
            'disabled' => 'false',
	        'dependency' => array(
		        'parameter' => 'embed_map',
		        'value' => 'false'
	        ),
        ),
	    'zoom' => array(
		    'type' => 'slider',
		    'label' => __('Zoom', 'mpce-gma'),
		    'default' => 13,
		    'min' => 0,
		    'max' => 20,
	        'dependency' => array(
		        'parameter' => 'embed_map',
		        'value' => 'false'
	        )
	    ),
        'embed_map' => array(
		    'type' => 'checkbox',
		    'label' => __('Use Embed Code', 'mpce-gma'),
		    'default' => 'false',
		    'description' => ''
	    ),
	    'embed_code' => array(
            'type' => 'longtext64',
            'label' => __('Embed code', 'mpce-gma'),
            'default' => '',
            'description' => sprintf( __('<a %s>Embed a map</a> from  Google Maps', 'mpce-gma'),
				'href="https://support.google.com/maps/answer/3544418?hl=en" target="_blank"'),
	        'dependency' => array(
		        'parameter' => 'embed_map',
		        'value' => 'true'
	        )
        ),
	    'scrollwheel' => array(
		    'type' => 'checkbox',
		    'label' => __('Scrollwheel zooming', 'mpce-gma'),
		    'default' => 'true',
	        'dependency' => array(
		        'parameter' => 'embed_map',
		        'value' => 'false'
	        )
	    ),
	    'draggable' => array(
		    'type' => 'checkbox',
		    'label' => __('Draggable map', 'mpce-gma'),
		    'default' => 'true',
	        'dependency' => array(
		        'parameter' => 'embed_map',
		        'value' => 'false'
	        )
	    ),
	    'disable_default_ui' => array(
		    'type' => 'checkbox',
		    'label' => __('Hide controls', 'mpce-gma'),
		    'default' => 'false',
	        'dependency' => array(
		        'parameter' => 'embed_map',
		        'value' => 'false'
	        )
	    ),
        'type' => array(
		    'type' => 'select',
		    'label' => __('Map type', 'mpce-gma'),
		    'default' => 'ROADMAP',
		    'list' => array(
			    'ROADMAP' => 'Road Map',
			    'HYBRID' => 'Hybrid',
			    'SATELLITE' => 'Satellite',
			    'TERRAIN' => 'Terrain'
		    ),
	        'dependency' => array(
		        'parameter' => 'embed_map',
		        'value' => 'false'
	        )
	    ),
	    'map_style' => array(
		    'type' => 'select',
		    'label' => __('Map style', 'mpce-gma'),
		    'default' => 'default',
		    'list' => array(
			    'default' => 'Default',
			    'custom' => 'Custom',
			    'subtle_grayscale' => 'Subtle Grayscale',
			    'blue_water' => 'Blue water',
			    'shades_of_grey' => 'Shades of Grey',
			    'pale_dawn' => 'Pale Dawn',
			    'blue_essence' => 'Blue Essence',
			    'apple_maps_esque' => 'Apple Maps-esque'
		    ),
	        'dependency' => array(
		        'parameter' => 'embed_map',
		        'value' => 'false'
	        )
	    ),
        'map_custom_style' => array(
            'type' => 'longtext64',
            'label' => __('Custom style', 'mpce-gma'),
            'default' => '',
            'description' => sprintf( __('Visit <a %1$s>Snazzy Maps</a> or <a %2$s>Styled Maps Wizard</a> to create your custom style',
				'mpce-gma'),
				'href="https://snazzymaps.com/" target="_blank"',
				'href="https://mapstyle.withgoogle.com/" target="_blank"'
			),
	        'dependency' => array(
		        'parameter' => 'map_style',
		        'value' => 'custom'
	        ),
        ),
	    'map_min_height' => array(
			    'type' => 'text',
			    'label' => __('Minimum Height', 'mpce-gma'),
			    'default' => '',
			    'description' => __('Example: 100px', 'mpce-gma'),
	    ),
		'showlinks' => array(
				'type' => 'checkbox',
				'label' => __('Display list of locations', 'mpce-gma'),
				'default' => 'false',
				'dependency' => array(
						'parameter' => 'embed_map',
						'value' => 'false'
				)
		),
		'link_columns' => array(
				'type' => 'radio-buttons',
				'label' => __('List columns count', 'mpce-gma'),
				'default' => 2,
				'list' => array(
						1 => 1,
						2 => 2,
						3 => 3,
						4 => 4
				),
				'dependency' => array(
						'parameter' => 'showlinks',
						'value' => 'true'
				)
		),
		'link_maxwidth' => array( //Max col width
				'type' => 'text',
				'label' => __('List maximum width', 'mpce-gma'),
				'default' => "100%",
				'description' =>  __('Maximum width of a list. Example: 100% or 800px.', 'mpce-gma'),
				'dependency' => array(
						'parameter' => 'showlinks',
						'value' => 'true'
				)
		)

    ), 91, MPCEObject::ENCLOSED, MPCEObject::RESIZE_ALL);


	// Rewrite icons
//	$icons = $mpceLibrary->getIconClassList();
//	$icons = array_map(function($icon) {
//		$icon['class'] = strtoupper(str_replace(array('fa ', 'fa-', '-'), array('', '', '_'), $icon['class']));
//		return $icon;
//	}, $icons);

//	$icons = array_map(function($icon) {
//		return $icon['class'];
//	}, $mpceLibrary->getIconClassList());

    $markerObj = new MPCEObject('mp_google_map_marker', __('MP Google Map Marker', 'mpce-gma'), null, array(
        'address' => array(
            'type' => 'text',
            'label' => __('Address', 'mpce-gma'),
            'default' => 'Sydney, New South Wales, Australia',
            'description' => ''
        ),
        'title' => array(
            'type' => 'text',
            'label' => __('Title', 'mpce-gma'),
            'default' => 'Title',
            'description' => ''
        ),
        'description' => array(
//            'type' => 'longtext',
            'type' => 'longtext-tinymce',
            'label' => __('Description', 'mpce-gma'),
            'default' => __('<p>Address: <strong>Sydney, New South Wales, Australia</strong><br /> Phone: <strong>+1 234 567890</strong><br /> E-mail: <a href="mailto:john@smith.com"><strong>john@smith.com</strong></a><br /> Hours: <strong>10 AM - 9 PM</strong></p>', 'mpce-gma'),
            'description' => '',
	        'text' => __('Edit', 'mpce-gma'),
            'saveInContent' => 'true'
        ),
        'link' => array(
            'type' => 'link',
            'label' => __('Link', 'mpce-gma'),
            'default' => '#',
            'description' => ''
        ),
	    'link_label' => array(
            'type' => 'text',
            'label' => __('Link label', 'mpce-gma'),
            'default' => 'Read more',
            'description' => ''
        ),
	    'icon_type' => array(
		    'type' => 'radio-buttons',
		    'label' => __('Icon type', 'mpce-gma'),
		    'default' => 'default',
		    'list' => array(
			    'default' => 'Default',
			    'media' => 'Media',
			    'font' => 'Font'
		    )
	    ),
        'media_icon' => array(
            'type' => 'image',
            'label' => __('Icon', 'mpce-gma'),
            'default' => 'fa fa-map-marker',
            'description' => '',
	        'dependency' => array(
		        'parameter' => 'icon_type',
		        'value' => 'media'
	        ),
        ),
	    'font_icon' => array(
            'type' => 'icon-picker',
            'label' => __('Icon', 'mpce-gma'),
            'default' => 'fa fa-map-marker',
            'list' => method_exists($mpceLibrary, 'getIconClassList') ? $mpceLibrary->getIconClassList() : array(),
		    'dependency' => array(
		        'parameter' => 'icon_type',
		        'value' => 'font'
	        ),
        ),
        'font_icon_color' => array(
            'type' => 'color-select',
            'label' => __('Icon Color', 'mpce-gma'),
            'default' => 'mp-text-color-red',
            'list' => array(
                'mp-text-color-default' => 'Default',
                'mp-text-color-red' => 'Red',
                'mp-text-color-pink-dreams' => 'Pink Dreams',
                'mp-text-color-warm' => 'Warm',
                'mp-text-color-hot-summer' => 'Hot Summer',
                'mp-text-color-olive-garden' => 'Olive Garden',
                'mp-text-color-green-grass' => 'Green Grass',
                'mp-text-color-skyline' => 'Skyline',
                'mp-text-color-aqua-blue' => 'Aqua Blue',
                'mp-text-color-violet' => 'Violet',
                'mp-text-color-dark-grey' => 'Dark Grey',
                'mp-text-color-black' => 'Black',
                'custom' => 'Custom'
            ),
	        'dependency' => array(
                'parameter' => 'icon_type',
                'value' => 'font'
            )
        ),
        'font_icon_custom_color' => array(
            'type' => 'color-picker',
            'label' => __('Icon Custom Color', 'mpce-gma'),
            'default' => '#000000',
            'dependency' => array(
                'parameter' => 'font_icon_color',
                'value' => 'custom'
            )
        ),
	    'font_icon_size' => array(
            'type' => 'select',
            'label' => __('Icon Size', 'mpce-gma'),
            'default' => 'default',
            'list' => array(
                'default' => 'Default',
                'custom' => 'Custom'
            ),
		    'dependency' => array(
		        'parameter' => 'icon_type',
		        'value' => 'font'
	        ),
        ),
        'font_icon_custom_size' => array(
            'type' => 'spinner',
            'label' => __('Icon Custom Size', 'mpce-gma'),
            'description' => __('Font Size in px', 'mpce-gma'),
            'min' => 1,
            'step' => 1,
            'max' => 500,
            'default' => 45,
            'dependency' => array(
                'parameter' => 'font_icon_size',
                'value' => 'custom'
            )
        ),
        'show_driving_direction_link' => array(
            'type' => 'checkbox',
            'label' => __('Show `driving direction` link', 'mpce-gma'),
            'default' => 'false',
            'description' => ''
        ),
        'driving_direction_label' => array(
            'type' => 'text',
            'label' => __('`Driving direction` link label', 'mpce-gma'),
            'default' => '',
            'description' => '',
	        'dependency' => array(
		        'parameter' => 'show_driving_direction_link',
		        'value' => 'true'
	        ),
        ),
    ), null, MPCEObject::ENCLOSED, MPCEObject::RESIZE_NONE, false);

    $mpceLibrary->addObject($mapObj, MPCEShortcode::PREFIX . 'other');
    $mpceLibrary->addObject($markerObj, MPCEShortcode::PREFIX . 'other');
}
add_action('mp_library', 'mpceGoogleMapsAddonLibrary', 11, 1);