<?php
if (!defined('ABSPATH')) exit;

function mpceGMASettingsTab($tabs) {
	$tabs[MPCE_GMA_PLUGIN_SHORT_NAME] = array(
		'label' => __('Google Maps', 'mpce-gma'),
		'priority' => 10,
		'callback' => 'mpceGMASettingsTabContent'
	);
	return $tabs;
}

function mpceGMASettingsTabContent() {
	if (isset($_GET['settings-updated']) && $_GET['settings-updated']) {
        add_settings_error(
            'mpceGMASettings',
            esc_attr('settings_updated'),
            __('Settings saved.', 'mpce-gma'),
            'updated'
        );
    }

	settings_errors('mpceGMASettings', false);
	echo '<form actoin="options.php" method="POST">';
//    settings_fields('mpceGMAOptionsFields');
	do_settings_sections('mpce_gma_options');
	echo '<p class="submit"><input type="submit" name="submit" id="submit" class="button-primary" value="' . __('Save', 'mpce-gma') . '" /></p>';
	echo '</form>';
}

function mpceGMASettingsSave() {
	if (!empty($_POST)) {
		$settings = get_option('mpce-gma-settings', array());

//		if (isset($_POST['server_api_key'])) {
//			$settings['server_api_key'] = $_POST['server_api_key'];
//		}
		if (isset($_POST['browser_api_key'])) {
			$settings['browser_api_key'] = $_POST['browser_api_key'];
		}

		update_option('mpce-gma-settings', $settings);

		wp_redirect(add_query_arg(array('page' => $_GET['page'], 'plugin' => $_GET['plugin'], 'settings-updated' => 'true'), admin_url('admin.php')));
	}
}

function mpceGMALicenseTab($tabs) {
    global $gmaLicense;
	$tabs[MPCE_GMA_PLUGIN_SHORT_NAME] = array(
		'label' => __('Google Maps Addon', 'mpce-gma'),
		'priority' => 10,
        'callback' => array(&$gmaLicense, 'renderPage')
	);
	return $tabs;
}

add_action('admin_init', 'mpceGMAInitOptions');
function mpceGMAInitOptions() {
    register_setting('mpceGMABrowserAPIOptionsFields', 'mpceGMABrowserAPIOptions');
    add_settings_section('mpceGMABrowserAPIOptionsFields', '', 'mpceGMABrowserAPIOptionsSecTxt', 'mpce_gma_options');
    add_settings_field('mpceGMABrowserAPIOptions', __('API Key', 'mpce-gma'), 'mpceGMABrowserAPISettings', 'mpce_gma_options', 'mpceGMABrowserAPIOptionsFields');

//    register_setting('mpceGMAServerAPIOptionsFields', 'mpceGMAServerAPIOptions');
//    add_settings_section('mpceGMAServerAPIOptionsFields', '', 'mpceGMAServerAPIOptionsSecTxt', 'mpce_gma_options');
//    add_settings_field('mpceGMAServerAPIOptions', __('Server API Key', 'mpce-gma'), 'mpceGMAServerAPISettings', 'mpce_gma_options', 'mpceGMAServerAPIOptionsFields');
}

function mpceGMAServerAPIOptionsSecTxt() {}
function mpceGMAServerAPISettings() {
	$settings = get_option('mpce-gma-settings', array());
    echo '<input type="text" name="server_api_key" class="regular-text" value="' . (isset($settings['server_api_key']) ? $settings['server_api_key'] : '') . '" />';
    echo '<p class="description">' . __('Server API key is used together with Geocoding API', 'mpce-gma') . '</p>';
}

function mpceGMABrowserAPIOptionsSecTxt() {}
function mpceGMABrowserAPISettings() {
	$settings = get_option('mpce-gma-settings', array());
    echo '<input type="text" name="browser_api_key" class="regular-text" value="' . (isset($settings['browser_api_key']) ? $settings['browser_api_key'] : '') . '" />';
//	echo '<p class="description">' . sprintf( __('It is not required to get <b>API keys</b> but Google recommends it in order to use the maps. <a %1$s>Follow this link</a> to obtain your API keys. In short, you need to:<br/>1. Enable "Google Maps JavaScript API" and "Google Maps Geocoding API" in <a %2$s>Google Developers Console</a><br/>2. Create Browser and Server API keys<br/>3. Paste them to these fields and save',
//			'mpce-gma') ,
//		'href="https://developers.google.com/maps/documentation/javascript/get-api-key" target="_blank"',
//		'href="https://console.developers.google.com/" target="_blank"')
//		. '</p>';
	echo '<p class="description">' . sprintf( __('It is not required to get <b>API key</b> but Google recommends it in order to use the maps. <a %1$s>Follow this link</a> to obtain your API key. In short, you need to:<br/>1. Enable "Google Maps JavaScript API" and "Google Maps Geocoding API" in <a %2$s>Google Developers Console</a><br/>2. Paste it to this field and save',
			'mpce-gma') ,
		'href="https://developers.google.com/maps/documentation/javascript/get-api-key" target="_blank"',
		'href="https://console.developers.google.com/" target="_blank"')
		. '</p>';
}