<?php
if (!defined('ABSPATH')) exit;

$mpceGMAShortcodeFunctions = array(
	'mp_google_map' => 'mpceGMAGoogleMapShortcode',
	'mp_google_map_marker' => 'mpceGMAMarkerShortcode'
);
foreach ($mpceGMAShortcodeFunctions as $sortcode_name => $function_name) {
    add_shortcode($sortcode_name, $function_name);
}

function mpceGMAGoogleMapShortcode($attrs, $content = null, $shortcodeName) {
	$defaultAttrs = array(
        'embed_map' => 'false',
        'embed_code' => '',
        'type' => 'ROADMAP',
        'style_map' => '',
        'scrollwheel' => 'true',
        'draggable' => 'true',
        'disable_default_ui' => 'false',
        'zoom' => '13',
        'map_style' => 'default',
        'map_min_height' => '',
        'map_custom_style' => '',
		'showlinks' => 'false',
		'link_maxwidth' => '100%',
		'link_columns' => '2'
    );
	$mpceActive = is_plugin_active('motopress-content-editor/motopress-content-editor.php') || is_plugin_active('motopress-content-editor-lite/motopress-content-editor.php');
    if ($mpceActive) $defaultAttrs = MPCEShortcode::addStyleAtts($defaultAttrs);
    extract(shortcode_atts($defaultAttrs, $attrs));

	wp_enqueue_style('mpce-gma-style');
	wp_enqueue_script('googlemap-fontawesome-markers');
	wp_enqueue_script('googlemapapis');
	wp_enqueue_script('mpce-gma-script');
	
	$output = '';

        $dataAttrs = '';
        $dataAttrs .= ' data-type="' . $type . '"';
        $dataAttrs .= ' data-scrollwheel="' . $scrollwheel . '"';
        $dataAttrs .= ' data-draggable="' . $draggable . '"';
        $dataAttrs .= ' data-disable-default-ui="' . $disable_default_ui . '"';
        $dataAttrs .= ' data-zoom="' . $zoom . '"';
        $dataAttrs .= ' data-map-style="' . $map_style . '"';

            if ($map_style && $map_style != 'default') {
                    $styleContent = '[]';
                    if ($map_style == 'custom') {
                            $map_custom_style = base64_decode(strip_tags($map_custom_style));
                    $map_custom_style = preg_replace('~[\r\n]~', '', $map_custom_style);
                            $styleContent = $map_custom_style;
                    } else {
                            $stylePath = MPCE_GMA_PLUGIN_DIR . 'assets/map_styles/' . $map_style . '.json';
                            if (file_exists($stylePath)) {
                                    $styleContent = file_get_contents($stylePath);
                            }
                    }
                    if (!json_decode($styleContent)) $styleContent = '[]';
                    $output .= "<p class=\"motopress-hide-script\"><script type=\"text/javascript\">
                    mpce_gma_styles = window.mpce_gma_styles || [];
                            mpce_gma_styles['".$map_style."'] = ".($styleContent ? $styleContent : '[]').";
                </script></p>";
            }

            $mpceClasses = '';
            if ($mpceActive) {
                    if (!empty($mp_style_classes)) $mp_style_classes = ' ' . $mp_style_classes;
                    $mpceClasses = MPCEShortcode::getBasicClasses($shortcodeName) . MPCEShortcode::getMarginClasses($margin) . $mp_style_classes;					
					if (method_exists('MPCEShortcode', 'handleCustomStyles')) {
						$mpceClasses .= MPCEShortcode::handleCustomStyles($mp_custom_style, $shortcodeName);
					}
            }

			$minHeight = (!empty($map_min_height)) ? 'style="min-height:'.$map_min_height.'"' : '';

            $output .= '<div class="mpce-gma-wrapper ' . $mpceClasses . '"' . $minHeight . '>';
            if ($embed_map === 'true') {
                    $embed_code = base64_decode(strip_tags($embed_code));
            $embed_code = preg_replace('~[\r\n]~', '', $embed_code);

                    $output .= $embed_code;
            } else {
                    $output .= '<div class="mpce-gma-map-canvas" ' . $dataAttrs . '></div>';
            }
            $output .= '<div class="mpce-gma-markers" style="display: none;">' . do_shortcode($content) . '</div>';

			if($showlinks === 'true' && $embed_map !== 'true'){

				$atts = mpce_get_all_attributes("mp_google_map_marker", $content);

				$rowAtts = array(
						'columns' => $link_columns
				);
				$output .= '<div class="mpce-gma-map-links" style="max-width: ' . $link_maxwidth . ';">' . mpceGMALinkShortcode($atts, $rowAtts) . '</div>';
			}

            $output .= '</div>';

	return $output;
}

function mpceGMAMarkerShortcode($attrs, $content = null, $shortcodeName) {
    $defaultAttrs = array(
        'address' => 'Sidney, New South Wales, Australia',
        'title' => '',
        'link' => '',
        'link_label' => '',
        'show_driving_direction_link' => 'false',
        'driving_direction_label' => 'Driving directions',
        'icon_type' => 'default', // default | media | font
        'media_icon' => '',
        'font_icon' => 'fa fa-map-marker',
	    'font_icon_size' => 'default',
        'font_icon_custom_size' => '45',
        'font_icon_color' => 'mp-text-color-red',
        'font_icon_custom_color' => '#000000'
    );

	$mpceActive = is_plugin_active('motopress-content-editor/motopress-content-editor.php') || is_plugin_active('motopress-content-editor-lite/motopress-content-editor.php');
    if ($mpceActive) $defaultAttrs = MPCEShortcode::addStyleAtts($defaultAttrs);
    extract(shortcode_atts($defaultAttrs, $attrs));

	$output = '';

	$link = trim($link);
	$address = trim($address);

	if ($address == '') return $output;

	// Check address type
	$addressType = 'address';
	$latLng = array();
	$_address = explode(',', $address);
	if (count($_address) === 2 and is_numeric($_address[0]) and is_numeric($_address[1])) {
		$addressType = 'latlng';
		$latLng = array(
			'lat' => (float) trim($_address[0]),
			'lng' => (float) trim($_address[1])
		);
	}

	// Get address data
	if ($addressType === 'address') {
		$addressData = mpceGMAGetAddressData($address);
		if (is_array($addressData)) {
			$latLng = $addressData['location'];
		} else {
			$output = $addressData;
		}
	}

	if (count($latLng)) {
		$dataAddress = ' data-address="' . $address . '"';
		$dataLatLng = ' data-lat-lng="' . htmlentities(json_encode($latLng)) . '"';

		$dataAttrs = '';
		$dataAttrs .= ' data-title="' . $title . '"';
		$dataAttrs .= ' data-address-type="' . $addressType . '"';
		$dataAttrs .= $dataAddress . $dataLatLng;
		$dataAttrs .= ' data-icon-type="' . $icon_type . '"';

		// Get media icon
		if ($icon_type === 'media') {
			$mediaIconSrc = false;
			if (isset($media_icon) && !empty($media_icon)) {
				$media_icon = (int)$media_icon;
				$attachment = get_post($media_icon);
				if (!empty($attachment) && $attachment->post_type === 'attachment') {
					if (wp_attachment_is_image($media_icon)) {
						$mediaIconSrc = wp_get_attachment_image_src($media_icon, 'full');
						$mediaIconSrc = ($mediaIconSrc && isset($mediaIconSrc[0])) ? $mediaIconSrc[0] : false;
					}
				}
			}
			$dataAttrs .= ' data-media-icon="' . ($mediaIconSrc ? $mediaIconSrc : 'false') . '"';

			// Get font icon
		} elseif ($icon_type === 'font') {
			wp_enqueue_style('mpce-font-awesome');

//			$font_icon = strtoupper(str_replace(array('fa ', 'fa-', '-'), array('', '', '_'), $font_icon));
			$dataAttrs .= ' data-font-icon="' . esc_attr($font_icon) . '"';

		    $dataAttrs .= ' data-font-icon-size="' . $font_icon_size . '"';
			$dataAttrs .= ' data-font-icon-color="' . $font_icon_color . '"';
		    if ($font_icon_color === 'custom') {
		        $dataAttrs .= ' data-font-icon-custom-color="' . $font_icon_custom_color . '"';
		    }
		    if ($font_icon_size === 'custom') {
		        $dataAttrs .= ' data-font-icon-custom-size="' . $font_icon_custom_size . '"';
		    }
//			<i class="' . esc_attr($icon) . $iconColorClass . $iconSizeClass .'" style="' . $iconColorStyle . $iconSizeStyle .'"></i>
		}

		// Prepare popup content
		if ($title) {
			$content = "<h2>$title</h2>" . $content;
		}

		$mpceClasses = '';
		if ($mpceActive) {
			$mpceClasses = MPCEShortcode::getBasicClasses('mp_google_map_marker') . MPCEShortcode::getMarginClasses($margin);
			if (method_exists('MPCEShortcode', 'handleCustomStyles')) {
				$mpceClasses .= MPCEShortcode::handleCustomStyles($mp_custom_style, $shortcodeName);
			}
		}

		$output .= '<div class="mpce-gma-marker ' . $mpceClasses . '" ' . $dataAttrs . '>';
		$output .= trim(do_shortcode($content));
		if ($link and $link_label) {
			$output .= '<div class="mpce-gma-marker-link-wrapprer"><a href="' . $link . '" class="mpce-gma-marker-link">' . $link_label . '</a></div>';
		}
		if ($show_driving_direction_link === 'true') {
			$output .= '<div style="padding-top:10px;"><a href="javascript:void(0)" class="mpce-gma-dd-link" ' . $dataAddress . $dataLatLng . '>' . $driving_direction_label . '</a></div>';
		}
		$output .= '</div>';
	}

    return $output;
}

function mpceGMALinkShortcode($attrs, $rowAtts) {
	$defaultAttrs = array(
			'address' => 'Sidney, New South Wales, Australia',
			'title' => '',
			'description' => ''
	);
	extract( $rowAtts );

	$rowClass = 'mp-row-fluid';
	$marcersCount = count( $attrs );

	$output = '<div class="' . $rowClass . '">';
	$i = 0;
	foreach( $attrs as $key => $attr ) {

		extract(shortcode_atts($defaultAttrs, $attr));
		$dataAttrs = '';
		$itemGridClass = 'mp-span' . ( 12 / $columns );

		$address = trim($address);
		if ($address == '') continue;

		$addressType = 'address';
		$latLng = array();
		$_address = explode(',', $address);
		if (count($_address) === 2 and is_numeric($_address[0]) and is_numeric($_address[1])) {
			$addressType = 'latlng';
			$latLng = array(
					'lat' => (float) trim($_address[0]),
					'lng' => (float) trim($_address[1])
			);
		}

		// Get address data
		if ($addressType === 'address') {
			$addressData = mpceGMAGetAddressData($address);
			if (is_array($addressData)) {
				$latLng = $addressData['location'];
			} else {
				$output .= $addressData;
			}
		}

		if (count($latLng)) {
			$dataAttrs .= ' data-lat-lng="' . htmlentities(json_encode($latLng)) . '"';
			$output .= "<div class='" . $itemGridClass . "'>" . "<a class='mpce-google-map-link' " . $dataAttrs . " href='javascript:void(0);'>" . $title . "</a></div>";
			$isRowFull = ($i % $columns == ($columns - 1) ) && ($i != $marcersCount - 1);

			if ( $isRowFull) {
				$output .= '</div>';
				$output .= '<div class="' . $rowClass . '">';
			}
			$i++;
		}
	}
	$output .= '</div>';

	return $output;
}

function mpceGMAGetAddressData($address) {
	$_address = str_replace(" ", "+", $address);

	$error = '';
	$addresses = get_transient('mpce-gma-addresses', array());
	$addresses = (false === $addresses) ? array() : $addresses;

	if (!array_key_exists($_address, $addresses)) {
		$settings = get_option('mpce-gma-settings', array());
//		$serverApiKey = (isset($settings['server_api_key']) && $settings['server_api_key']) ? '&key=' . $settings['server_api_key'] : '';
		$serverApiKey = (isset($settings['browser_api_key']) && $settings['browser_api_key']) ? '&key=' . $settings['browser_api_key'] : '';

		$url = 'https://maps.googleapis.com/maps/api/geocode/json?address=' . $_address . $serverApiKey;
		$response = wp_remote_get($url, array('timeout' => 15, 'sslverify' => false));
		if (is_wp_error($response)) {
	        $errors = $response->get_error_codes();
	        foreach ($errors as $key => $code) {
	            $error .= $response->get_error_message($code) . '<br>';
	        }
	        return $error;
	    }
		$data = json_decode(wp_remote_retrieve_body($response));

		if ($data && isset($data->status)) {
			if ($data->status === 'OK') {
				if ($data && isset($data->results)) {
					$results = $data->{'results'};
					if ($results && $results[0]) {
						$latLng = (array) $results[0]->{'geometry'}->{'location'};
						$expiration = 60 * 60 * 24; // one day
						$addresses[$_address]['location'] = $latLng;
						set_transient('mpce-gma-addresses', $addresses, $expiration);
					}
				}
			} else {
				switch ($data->status) {
					case 'ZERO_RESULTS' :
						$error = __('Nothing found. Please enter correct address.', 'mpce-gma');
						break;
					case 'OVER_QUERY_LIMIT' :
						$error = __('Usage limits exceeded.', 'mpce-gma');
						break;
					case 'REQUEST_DENIED' :
						$error = __('Request was denied for some reason.', 'mpce-gma');
						break;
					case 'INVALID_REQUEST' :
						$error = __('Query (address) is missing.', 'mpce-gma');
						break;
				}
			}
		} else {
			$error = _('Bad response from Google Map API.', 'mpce-gma');
		}
	}

	return (array_key_exists($_address, $addresses) && count($addresses[$_address])) ? $addresses[$_address] : $error;
}

/**
 * @param  string $tag   Shortcode tag
 * @param  string $text  Text containing shortcodes
 * @return array  $out   Array of attributes
 */
function mpce_get_all_attributes($tag, $text){
	preg_match_all( '/' . get_shortcode_regex() . '/s', $text, $matches );
	$out = array();
	if( isset($matches[2]) ){
		foreach((array)$matches[2] as $key=>$value){
			if( $tag === $value )
				$out[] = shortcode_parse_atts( $matches[3][$key] );
		}
	}
	return $out;
}
