<?php

add_action('mpce_add_simple_shortcode', 'mpceGMAAddSimpleShortcode');

function mpceGMAAddSimpleShortcode() {
	add_shortcode('mp_google_map', 'mpceGMAGoogleMapShortcodeSimple');
	add_shortcode('mp_google_map_marker', 'mpceGMAMarkerShortcodeSimple');
}

function mpceGMAGoogleMapShortcodeSimple($attrs, $content = null) {
	extract(shortcode_atts(array(
		'type' => 'ROADMAP',
        'embed_map' => 'false',
        'embed_code' => '',
        'zoom' => '13'
    ), $attrs));

	if ($embed_map === 'false') {
		$typesAssoc = array(
			'ROADMAP' => 'm',
		    'HYBRID' => 'h',
		    'SATELLITE' => 'k',
		    'TERRAIN' => 'p'
		);
		$type = isset($typesAssoc[$type]) ? $typesAssoc[$type] : 'm';

		$output = '<iframe frameborder="0" scrolling="no" marginheight="0" marginwidth="0" src="https://maps.google.com/maps?t=' . $type . '&amp;z=' . $zoom . '&amp;output=embed&amp;iwloc=near"></iframe>';

		$content = trim(do_shortcode($content));
		if (!empty($content)) {
			$output .= "<br><ul>{$content}</ul>";
		}
	}
	else {
		$embed_code = base64_decode(strip_tags($embed_code));
        $embed_code = preg_replace('~[\r\n]~', '', $embed_code);
		$output = $embed_code;
	}

	return $output;
}

function mpceGMAMarkerShortcodeSimple($attrs, $content = null) {
	extract(shortcode_atts(array(
        'address' => 'Sidney, New South Wales, Australia',
        'title' => '',
        'link' => '',
        'link_label' => ''
    ), $attrs));

    $content = trim(do_shortcode($content));

    $output = '<li>';
    $output .= $title;
    $output .= '<br>' . $address;
    if (!empty($content)) {
	    $output .= "<br>{$content}";
    }
	if ($link && $link_label) {
		$output .= '<br><a href="' . $link . '">' . $link_label . '</a>';
	}
    $output .= '</li>';

	return $output;
}

